QCPAxisTickerPi Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions
QCPAxisTickerPi Class Reference

Specialized axis ticker to display ticks in units of an arbitrary constant, for example pi. More...

Inheritance diagram for QCPAxisTickerPi:

## Public Types
enum | FractionStyle
Public Types inherited from QCPAxisTicker
enum | TickStepStrategy

## Public Functions
| QCPAxisTickerPi ()
QString | piSymbol () const
double | piValue () const
bool | periodicity () const
FractionStyle | fractionStyle () const
void | setPiSymbol (QString symbol)
void | setPiValue (double pi)
void | setPeriodicity (int multiplesOfPi)
void | setFractionStyle (FractionStyle style)
Public Functions inherited from QCPAxisTicker
| QCPAxisTicker ()
TickStepStrategy | tickStepStrategy () const
int | tickCount () const
double | tickOrigin () const
void | setTickStepStrategy (TickStepStrategy strategy)
void | setTickCount (int count)
void | setTickOrigin (double origin)
virtual void | generate (const QCPRange &range, const QLocale &locale, QChar formatChar, int precision, QVector< double > &ticks, QVector< double > *subTicks, QVector< QString > *tickLabels)

## Protected Functions
virtual double | getTickStep (const QCPRange &range)
virtual int | getSubTickCount (double tickStep)
virtual QString | getTickLabel (double tick, const QLocale &locale, QChar formatChar, int precision)
void | simplifyFraction (int &numerator, int &denominator) const
QString | fractionToString (int numerator, int denominator) const
QString | unicodeFraction (int numerator, int denominator) const
QString | unicodeSuperscript (int number) const
QString | unicodeSubscript (int number) const
Protected Functions inherited from QCPAxisTicker
virtual QVector< double > | createTickVector (double tickStep, const QCPRange &range)
virtual QVector< double > | createSubTickVector (int subTickCount, const QVector< double > &ticks)
virtual QVector< QString > | createLabelVector (const QVector< double > &ticks, const QLocale &locale, QChar formatChar, int precision)
void | trimTicks (const QCPRange &range, QVector< double > &ticks, bool keepOneOutlier) const
double | pickClosest (double target, const QVector< double > &candidates) const
double | getMantissa (double input, double *magnitude=nullptr) const
double | cleanMantissa (double input) const

## Detailed Description

Specialized axis ticker to display ticks in units of an arbitrary constant, for example pi.

This QCPAxisTicker subclass generates ticks that are expressed with respect to a given symbolic constant with a numerical value specified with setPiValue and an appearance in the tick labels specified with setPiSymbol.

Ticks may be generated at fractions of the symbolic constant. How these fractions appear in the tick label can be configured with setFractionStyle.

The ticker can be created and assigned to an axis like this:

QSharedPointer<QCPAxisTickerPi> piTicker(new QCPAxisTickerPi);
customPlot->xAxis->setTicker(piTicker);

## Member Enumeration Documentation

## ◆ FractionStyle

enum QCPAxisTickerPi::FractionStyle

Defines how fractions should be displayed in tick labels.

See also
  setFractionStyle

Enumerator
fsFloatingPoint | Fractions are displayed as regular decimal floating point numbers, e.g. "0.25" or "0.125".
fsAsciiFractions | Fractions are written as rationals using ASCII characters only, e.g. "1/4" or "1/8".
fsUnicodeFractions | Fractions are written using sub- and superscript UTF-8 digits and the fraction symbol.

## Constructor & Destructor Documentation

## ◆ QCPAxisTickerPi()

QCPAxisTickerPi::QCPAxisTickerPi | ( |  | ) |

Constructs the ticker and sets reasonable default values. Axis tickers are commonly created managed by a QSharedPointer, which then can be passed to QCPAxis::setTicker.

## Member Function Documentation

## ◆ setPiSymbol()

void QCPAxisTickerPi::setPiSymbol | ( | QString | symbol | ) |

Sets how the symbol part (which is always a suffix to the number) shall appear in the axis tick label.

If a space shall appear between the number and the symbol, make sure the space is contained in symbol.

## ◆ setPiValue()

void QCPAxisTickerPi::setPiValue | ( | double | pi | ) |

Sets the numerical value that the symbolic constant has.

This will be used to place the appropriate fractions of the symbol at the respective axis coordinates.

## ◆ setPeriodicity()

void QCPAxisTickerPi::setPeriodicity | ( | int | multiplesOfPi | ) |

Sets whether the axis labels shall appear periodicly and if so, at which multiplicity of the symbolic constant.

To disable periodicity, set multiplesOfPi to zero.

For example, an axis that identifies 0 with 2pi would set multiplesOfPi to two.

## ◆ setFractionStyle()

void QCPAxisTickerPi::setFractionStyle | ( | QCPAxisTickerPi::FractionStyle | style | ) |

Sets how the numerical/fractional part preceding the symbolic constant is displayed in tick labels. See FractionStyle for the various options.

## ◆ getTickStep()

double QCPAxisTickerPi::getTickStep | ( | const QCPRange & | range | ) |
| protectedvirtual

Returns the tick step, using the constant's value (setPiValue) as base unit. In consequence the numerical/fractional part preceding the symbolic constant is made to have a readable mantissa.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## ◆ getSubTickCount()

int QCPAxisTickerPi::getSubTickCount | ( | double | tickStep | ) |
| protectedvirtual

Returns the sub tick count, using the constant's value (setPiValue) as base unit. In consequence the sub ticks divide the numerical/fractional part preceding the symbolic constant reasonably, and not the total tick coordinate.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## ◆ getTickLabel()

QString QCPAxisTickerPi::getTickLabel | ( | double | tick,
|  | const QLocale & | locale,
|  | QChar | formatChar,
|  | int | precision )
| protectedvirtual

Returns the tick label as a fractional/numerical part and a symbolic string as suffix. The formatting of the fraction is done according to the specified setFractionStyle. The appended symbol is specified with setPiSymbol.

For general information about this virtual method, see the base class implementation.

Reimplemented from QCPAxisTicker.

## ◆ simplifyFraction()

void QCPAxisTickerPi::simplifyFraction | ( | int & | numerator,
|  | int & | denominator ) const
| protected

Takes the fraction given by numerator and denominator and modifies the values to make sure the fraction is in irreducible form, i.e. numerator and denominator don't share any common factors which could be cancelled.

## ◆ fractionToString()

QString QCPAxisTickerPi::fractionToString | ( | int | numerator,
|  | int | denominator ) const
| protected

Takes the fraction given by numerator and denominator and returns a string representation. The result depends on the configured fraction style (setFractionStyle).

This method is used to format the numerical/fractional part when generating tick labels. It simplifies the passed fraction to an irreducible form using simplifyFraction and factors out any integer parts of the fraction (e.g. "10/4" becomes "2 1/2").

## ◆ unicodeFraction()

QString QCPAxisTickerPi::unicodeFraction | ( | int | numerator,
|  | int | denominator ) const
| protected

Returns the unicode string representation of the fraction given by numerator and denominator. This is the representation used in fractionToString when the fraction style (setFractionStyle) is fsUnicodeFractions.

This method doesn't use the single-character common fractions but builds each fraction from a superscript unicode number, the unicode fraction character, and a subscript unicode number.

## ◆ unicodeSuperscript()

QString QCPAxisTickerPi::unicodeSuperscript | ( | int | number | ) | const
| protected

Returns the unicode string representing number as superscript. This is used to build unicode fractions in unicodeFraction.

## ◆ unicodeSubscript()

QString QCPAxisTickerPi::unicodeSubscript | ( | int | number | ) | const
| protected

Returns the unicode string representing number as subscript. This is used to build unicode fractions in unicodeFraction.

The documentation for this class was generated from the following files:

- src/axis/axistickerpi.h
- src/axis/axistickerpi.cpp